Package io.vertx.core.spi.metrics

## Interface EventBusMetrics<H>

- All Superinterfaces:
    `Metrics`

      public interface EventBusMetrics<H>
      extends Metrics

  The event bus metrics SPI which Vert.x will use to call when each event occurs.
  Author:
    Nick Scavelli

- - ### Field Summary

    - ### Fields inherited from interface io.vertx.core.spi.metrics.Metrics

      `METRICS_ENABLED`

  - ### Method Summary

    All Methods Instance Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default void` | `discardMessage​(H handler, boolean local, Message<?> msg)` | Discard a message.
    `default H` | `handlerRegistered​(String address)` | Called when a handler is registered on the event bus.
    `default void` | `handlerUnregistered​(H handler)` | Called when a handler has been unregistered from the event bus.
    `default void` | `messageDelivered​(H handler, boolean local)` | Called when an handler has been delivered a message.
    `default void` | `messageRead​(String address, int numberOfBytes)` | A message has been received from the network.
    `default void` | `messageReceived​(String address, boolean publish, boolean local, int handlers)` | Called when a message is received.
    `default void` | `messageSent​(String address, boolean publish, boolean local, boolean remote)` | Called when a message has been sent or published.
    `default void` | `messageWritten​(String address, int numberOfBytes)` | A message has been sent over the network.
    `default void` | `replyFailure​(String address, ReplyFailure failure)` | Called whenever the event bus delivers a reply failure to the sender/publisher, the `reply failure` indicates the nature of the failure.
    `default void` | `scheduleMessage​(H handler, boolean local)` | Schedule a message for processing.

    - ### Methods inherited from interface io.vertx.core.spi.metrics.Metrics

      `close`

- - ### Method Detail

    - #### handlerRegistered

          default H handlerRegistered​(String address)

      Called when a handler is registered on the event bus.

      No specific thread and context can be expected when this method is called.

      Parameters:
        `address` - the address used to register the handler

    - #### handlerUnregistered

          default void handlerUnregistered​(H handler)

      Called when a handler has been unregistered from the event bus.

      No specific thread and context can be expected when this method is called.
      Parameters:
        `handler` - the unregistered handler

    - #### scheduleMessage

          default void scheduleMessage​(H handler,
                                       boolean local)

      Schedule a message for processing.

      No specific thread and context can be expected when this method is called.
      Parameters:
        `handler` - the handler processing the message
        `local` - when the scheduled message is local

    - #### discardMessage

          default void discardMessage​(H handler,
                                      boolean local,
                                      Message<?> msg)

      Discard a message.
      Parameters:
        `handler` - the handler processing the message
        `local` - when the scheduled message is local
        `msg` - the discarded message

    - #### messageDelivered

          default void messageDelivered​(H handler,
                                        boolean local)

      Called when an handler has been delivered a message. No specific thread and context can be expected when this method is called.
      Parameters:
        `handler` - the handler processing the message
        `local` - when the handled message is local

    - #### messageSent

          default void messageSent​(String address,
                                   boolean publish,
                                   boolean local,
                                   boolean remote)

      Called when a message has been sent or published.

      No specific thread and context can be expected when this method is called.
      Parameters:
        `address` - the address
        `publish` - true when the message is published
        `local` - the message is processed locally
        `remote` - the message is sent on the cluster

    - #### messageReceived

          default void messageReceived​(String address,
                                       boolean publish,
                                       boolean local,
                                       int handlers)

      Called when a message is received.

      No specific thread and context can be expected when this method is called.
      Parameters:
        `address` - the address
        `publish` - true when the message is published
        `local` - true when the message is received locally
        `handlers` - the number of handlers that process the message

    - #### messageWritten

          default void messageWritten​(String address,
                                      int numberOfBytes)

      A message has been sent over the network.

      No specific thread and context can be expected when this method is called.
      Parameters:
        `address` - the message address
        `numberOfBytes` - the number of bytes written

    - #### messageRead

          default void messageRead​(String address,
                                   int numberOfBytes)

      A message has been received from the network.

      No specific thread and context can be expected when this method is called.
      Parameters:
        `address` - the message address
        `numberOfBytes` - the number of bytes read

    - #### replyFailure

          default void replyFailure​(String address,
                                    ReplyFailure failure)

      Called whenever the event bus delivers a reply failure to the sender/publisher, the `reply failure` indicates the nature of the failure.

      No specific thread and context can be expected when this method is called.
      Parameters:
        `address` - the address
        `failure` - the `ReplyFailure`